(:Tally to DBF:)
(:XML to DBF:)

(: NOTES :)
(: Point 1 - This XQuery Update creates following tables and inserts data into the tables :)

(:Main Voucher Table - mvoucher.dbf :)
(:mvoucher.dbf fields :)
(:COL1 - VCHID:)
(:COL2 - VCHTYPE:)
(:COL3 - VCHDATE:)
(:COL4 - VCHNUMBER:)
(:COL5 - REFERENCE:)
(:COL6 - NARRATION:)

(:Child Table -  ledvouch.dbf :)
(:ledvouch.dbf  fields:)
(:COL1 - VCHID:)
(:COL2 - LEDGER:)
(:COL3 - AMOUNT:)

(:Child Table -  Invvouch.dbf :)
(:ledvouch.dbf  fields:)
(:COL1 - VCHID:)
(:COL2 - ITEMNAME:)
(:COL3 - QTY:)
(:COL4 - RATE:)
(:COL5 - AMOUNT:)


(: Point 2 - Connection String has to be changed in case if you wish to redirect output to other databases like SQL-Server or MySQL or some other Database :)

(: The default ConnectionString specified in the RTSXQueryFreemium.ini file is for DBASE which is as follows :)
(:
   ConnectionString = 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\RTSXQueryFreemiumV1.0;Extended Properties="dBASE IV;User ID=Admin;Password=;"'
:)


(:XQuery - Section 1 - Variable declaration :)

declare variable $xtable1 as item()* := 
(
	for
		$row  in (ENVELOPE/BODY/IMPORTDATA/REQUESTDATA/TALLYMESSAGE/VOUCHER)
		let
		$vchid          := $row/parent::node()/@MASTERID,
		$vchtype        := $row/@VCHTYPE,
		$vchdate        := $row/DATE,
		$vchnumber      := $row/VOUCHERNUMBER,
		$reference      := $row/REFERENCE,
		$narration      := $row/NARRATION,
		$fieldnames:= ("VCHID","VCHTYPE","VCHDATE","VCHNUMBER","REFERENCE","NARRATION"),
		$fieldvalues:=($vchid,$vchtype,$vchdate,if (fn:exists($vchnumber)) then $vchnumber else "",if (fn:exists($reference)) then $reference else "",if (fn:exists($narration)) then $narration else "")
		return
			sslib:sql-insert('mvoucher',$fieldnames,$fieldvalues)
);

declare variable $xtable2 as item()* := 
(
	for
		$row  in (ENVELOPE/BODY/IMPORTDATA/REQUESTDATA/TALLYMESSAGE/VOUCHER),
		$ledger in distinct-values($row/descendant::LEDGERNAME)
		let
		$vchid       := $row/parent::node()/@MASTERID,
		$amount      := sum($row/descendant::LEDGERNAME[.=$ledger]/parent::node()/AMOUNT),
		$fieldnames:= ("VCHID","LEDGER","AMOUNT"),
		$fieldvalues:=($vchid,$ledger,$amount)
		return
			sslib:sql-insert('ledvouch',$fieldnames,$fieldvalues)
);

declare variable $xtable3 as item()* := 
(
	for 
		$row  in (ENVELOPE/BODY/IMPORTDATA/REQUESTDATA/TALLYMESSAGE/VOUCHER),
		$stockitem at $pos in ($row/ALLINVENTORYENTRIES.LIST/STOCKITEMNAME)
		let
		$vchid       := $row/parent::node()/@MASTERID,
		$qty := ($row/ALLINVENTORYENTRIES.LIST[ACTUALQTY]/number(substring-before(normalize-space(data(ACTUALQTY)),' ')))[$pos],
		$rate := ($row/ALLINVENTORYENTRIES.LIST/RATE)[$pos],
		$amount := ($row/ALLINVENTORYENTRIES.LIST/AMOUNT)[$pos],
		$fieldnames:= ("VCHID","ITEM","QTY","RATE","AMOUNT"),
		$fieldvalues:=($vchid,$stockitem,if (fn:exists($qty)) then sum($qty) else 0,if (fn:exists($rate)) then data($rate) else "",if (fn:exists($amount)) then data($amount) else 0)
		return
			sslib:sql-insert('invvouch',$fieldnames,$fieldvalues)
);


(:XQuery Section 2 - XQuery begins here:)

<output>

(: create the table mvoucher, if it does not exist :)
<createtable>
CREATE TABLE mvoucher.dbf (VCHID CHAR(30),[VCHTYPE] CHAR(50),[VCHDATE] char(20),[VCHNUMBER] char(60),[REFERENCE] char(50),[NARRATION] char(100));
</createtable>

(: create the table ledvouch.dbf, if it does not exist :)
<createtable>
CREATE TABLE ledvouch.dbf (VCHID CHAR(30),[LEDGER] char(100),[AMOUNT] FLOAT);
</createtable>

(: create the table invvouch.dbf, if it does not exist :)
<createtable>
CREATE TABLE invvouch.dbf (VCHID CHAR(30),[ITEM] char(100),[QTY] FLOAT,[RATE] char(50),[AMOUNT] FLOAT);
</createtable>

(: get the value of variable $xtable1 - i.e. execute sslib:sql-insert() which inserts data into table mvoucher :)
{$xtable1}

(: get the value of variable $xtable2 - i.e. execute sslib:sql-insert() which inserts data into table ledvouch :)
{$xtable2}

(: get the value of variable $xtable3 - i.e. execute sslib:sql-insert() which inserts data into table invvouch :)
{$xtable3}

</output>
	